#!/bin/sh

createRedHatScript() {
	(
cat <<-EOF
	#!/bin/sh
	
	#chkconfig: 2345 99 01
	#description:  Optim Management Server 

	# Source in function library
	. /etc/rc.d/init.d/functions

	# Start or stop
	OPTIM=$LOCATION/../../..
	WASCE=$LOCATION
	BIN=\$WASCE/bin
	PID_FILE=/var/run/optimmgmtserver.pid
	
	# Ensure open file limit is sufficient 
	ulimit -n 20048
	
	# Shell functions
	_start() {
		if [ ! -f \$PID_FILE ]
		then
			(
			cat <<-DAEMON_HEREDOC
				#!/bin/sh
				cd \$BIN
				\$OPTIM/shared/jdk/jre/bin/java -Xmx512m -javaagent:\$OPTIM/shared/WebSphere/AppServerCommunityEdition/bin/jpa.jar -Dorg.apache.geronimo.home.dir=\$OPTIM/shared/WebSphere/AppServerCommunityEdition -Djava.io.tmpdir=var/temp -Djava.endorsed.dirs=\$OPTIM/shared/WebSphere/AppServerCommunityEdition/lib/endorsed:\$OPTIM/shared/jdk/jre/lib/endorsed -Djava.ext.dirs=\$OPTIM/shared/WebSphere/AppServerCommunityEdition/lib/ext:\$OPTIM/shared/jdk/jre/lib/ext -jar \$OPTIM/shared/WebSphere/AppServerCommunityEdition/bin/server.jar --long	2>\$WASCE/var/log/service.err 1>\$WASCE/var/log/service.out &
				# We don't have credentials to write to /var/run as $USER. 
				#  We write PID to temporary file and get it later. 
				echo \\\$! >/tmp/optimmgmtserver.pid
			DAEMON_HEREDOC
			) > /tmp/\$$
			chmod +x /tmp/\$$
			echo -n Starting Optim management service
			daemon --user $USER /tmp/\$$
			if [ \$? -eq 0 ]
			then
				cp /tmp/optimmgmtserver.pid \$PID_FILE
				chown $USER \$PID_FILE
			fi
			rm -f /tmp/\$$
			rm -f /tmp/optimmgmtserver.pid
			echo
		fi
	}


	_stop() {
		if [ -s \$PID_FILE ]
		then
			echo -n Stopping optim management service
			PID=\`cat \$PID_FILE\`
			killproc -p \$PID_FILE java -9
			RC=\$?
			if [ \$RC -eq 0 ] 
			then
				# If here, there was a process to kill.
				# Wait for the process to go away before deleting the pid file.
				ps -fu $USER -p $\PID >/dev/null 2>&1
				RC=\$?
				while [ \$RC -eq 0 ]
				do
					sleep 5
					ps -fu $USER -p $\PID >/dev/null 2>&1
					RC=\$?
				done		
				rm -f \$PID_FILE
			fi
			echo
		fi
	}

	case "\$1" in
		"start")
			_start
			;;
		"stop")
			_stop
			;;
		"restart")
			_stop
			_start
			;;
	esac
EOF
	) > $OUTFILE
#	chmod +x $OUTFILE
}

createAIXScript() {
	(
	cat <<-EOF
	#!/bin/sh
	
	# Start or stop
	OPTIM=$LOCATION/../../..
	WASCE=$LOCATION
	BIN=\$WASCE/bin
	PID_FILE=/var/run/optimmgmtserver.pid
	
	# Ensure open file limit is sufficient 
	ulimit -n 20048
	
	# Shell functions
	_start() {
		if [ ! -f \$PID_FILE ]
		then
			(
			cat <<-DAEMON_HEREDOC
				#!/bin/sh
				cd \$BIN
				\$OPTIM/shared/jdk/jre/bin/java -Xmx512m -javaagent:\$OPTIM/shared/WebSphere/AppServerCommunityEdition/bin/jpa.jar -Dorg.apache.geronimo.home.dir=\$OPTIM/shared/WebSphere/AppServerCommunityEdition -Djava.io.tmpdir=var/temp -Djava.endorsed.dirs=\$OPTIM/shared/WebSphere/AppServerCommunityEdition/lib/endorsed:\$OPTIM/shared/jdk/jre/lib/endorsed -Djava.ext.dirs=\$OPTIM/shared/WebSphere/AppServerCommunityEdition/lib/ext:\$OPTIM/shared/jdk/jre/lib/ext -jar \$OPTIM/shared/WebSphere/AppServerCommunityEdition/bin/server.jar --long	2>\$WASCE/var/log/service.err 1>\$WASCE/var/log/service.out &
				# We don't have credentials to write to /var/run as $USER. 
				#  We write PID to temporary file and get it later. 
				echo \\\$! >/tmp/optimmgmtserver.pid
			DAEMON_HEREDOC
			) > /tmp/\$$
			chmod +x /tmp/\$$
			echo Starting Optim management service
			#daemon --user $USER /tmp/\$$
			su $USER -c /tmp/\$$
			if [ \$? -eq 0 ]
			then
				cp /tmp/optimmgmtserver.pid \$PID_FILE
				chown $USER \$PID_FILE
			fi
			rm -f /tmp/\$$
			rm -f /tmp/optimmgmtserver.pid
		fi
	}


	_stop() {
		if [ -s \$PID_FILE ]
		then
			echo Stopping optim management service
			PID=\`cat \$PID_FILE\`
			#killproc -p \$PID_FILE java -9
			kill -9 \$PID
			RC=\$?
			if [ \$RC -eq 0 ] 
			then
				# If here, there was a process to kill.
				# Wait for the process to go away before deleting the pid file.
				ps -fu $USER -p $\PID >/dev/null 2>&1
				RC=\$?
				while [ \$RC -eq 0 ]
				do
					sleep 5
					ps -fu $USER -p $\PID >/dev/null 2>&1
					RC=\$?
				done		
				rm -f \$PID_FILE
			fi
		fi
	}

	case "\$1" in
		"start")
			_start
			;;
		"stop")
			_stop
			;;
		"restart")
			_stop
			_start
			;;
	esac
EOF
	) > $OUTFILE
	chmod +x $OUTFILE
}

createSunOSScript() {
	(
	cat <<-EOF
	#!/bin/sh
	
	# Start or stop
	OPTIM=$LOCATION/../../..
	WASCE=$LOCATION
	BIN=\$WASCE/bin
	PID_FILE=/var/run/optimmgmtserver.pid
	
	# Ensure open file limit is sufficient 
	ulimit -n 20048
	
	# Shell functions
	_start() {
		if [ ! -f \$PID_FILE ]
		then
			(
			cat <<-DAEMON_HEREDOC
				#!/bin/sh
				cd \$BIN
				\$OPTIM/shared/jdk/jre/bin/java -Xmx512m -javaagent:\$OPTIM/shared/WebSphere/AppServerCommunityEdition/bin/jpa.jar -Dorg.apache.geronimo.home.dir=\$OPTIM/shared/WebSphere/AppServerCommunityEdition -Djava.io.tmpdir=var/temp -Djava.endorsed.dirs=\$OPTIM/shared/WebSphere/AppServerCommunityEdition/lib/endorsed:\$OPTIM/shared/jdk/jre/lib/endorsed -Djava.ext.dirs=\$OPTIM/shared/WebSphere/AppServerCommunityEdition/lib/ext:\$OPTIM/shared/jdk/jre/lib/ext -jar \$OPTIM/shared/WebSphere/AppServerCommunityEdition/bin/server.jar --long	2>\$WASCE/var/log/service.err 1>\$WASCE/var/log/service.out &
				# We don't have credentials to write to /var/run as $USER. 
				#  We write PID to temporary file and get it later. 
				echo \\\$! >/tmp/optimmgmtserver.pid
			DAEMON_HEREDOC
			) > /tmp/\$$
			chmod +x /tmp/\$$
			echo Starting Optim management service
			#daemon --user $USER /tmp/\$$
			su $USER -c /tmp/\$$
			if [ \$? -eq 0 ]
			then
				cp /tmp/optimmgmtserver.pid \$PID_FILE
				chown $USER \$PID_FILE
			fi
			rm -f /tmp/\$$
			rm -f /tmp/optimmgmtserver.pid
		fi
	}


	_stop() {
		if [ -s \$PID_FILE ]
		then
			echo Stopping optim management service
			PID=\`cat \$PID_FILE\`
			#killproc -p \$PID_FILE java -9
			kill -9 \$PID
			RC=\$?
			if [ \$RC -eq 0 ] 
			then
				# If here, there was a process to kill.
				# Wait for the process to go away before deleting the pid file.
				ps -fu $USER -p $\PID >/dev/null 2>&1
				RC=\$?
				while [ \$RC -eq 0 ]
				do
					sleep 5
					ps -fu $USER -p $\PID >/dev/null 2>&1
					RC=\$?
				done		
				rm -f \$PID_FILE
			fi
		fi
	}

	case "\$1" in
		"start")
			_start
			;;
		"stop")
			_stop
			;;
		"restart")
			_stop
			_start
			;;
	esac
EOF
	) > $OUTFILE
	chmod +x $OUTFILE
}

createUbuntuScript() {
	(
	cat <<-EOF
	#!/bin/sh
	
	### BEGIN INIT INFO
	# Provides:		optim-mgmtserver
	# Required-Start:    $remote_fs $syslog
	# Required-Stop:	$remote_fs $syslog
	# Default-Start:	2 3 4 5
	# Default-Stop:	 0 1 6
	# Short-Description: Start Optim Management Server as daemon at boot time
	# Description:	  Enable service provided by optim-mgmtserver daemon.
	### END INIT INFO
	
	# Start or stop
	OPTIM=$LOCATION/../../..
	WASCE=$LOCATION
	BIN=\$WASCE/bin

	# Ensure open file limit is sufficient 
	ulimit -n 20048
	
	# Shell functions
	_start() {
		if [ ! -f /var/run/optimmgmtserver.pid ]
		then
			(
			cat <<-DAEMON_HEREDOC
				#!/bin/sh
				cd \$BIN
				\$OPTIM/shared/jdk/jre/bin/java -Xmx512m -javaagent:\$OPTIM/shared/WebSphere/AppServerCommunityEdition/bin/jpa.jar -Dorg.apache.geronimo.home.dir=\$OPTIM/shared/WebSphere/AppServerCommunityEdition -Djava.io.tmpdir=var/temp -Djava.endorsed.dirs=\$OPTIM/shared/WebSphere/AppServerCommunityEdition/lib/endorsed:\$OPTIM/shared/jdk/jre/lib/endorsed -Djava.ext.dirs=\$OPTIM/shared/WebSphere/AppServerCommunityEdition/lib/ext:\$OPTIM/shared/jdk/jre/lib/ext -jar \$OPTIM/shared/WebSphere/AppServerCommunityEdition/bin/server.jar --long	2>\$WASCE/var/log/service.err 1>\$WASCE/var/log/service.out &
				echo \\\$!
			DAEMON_HEREDOC
			) > /tmp/\$$
			chmod +x /tmp/\$$
			echo -n Starting optim management service
			PID=\`start-stop-daemon --start --chuid $USER --chdir \$BIN --pidfile /tmp/$$.fakepid --startas /tmp/\$$\` 
			if [ \$? -eq 0 ]
			then
				rm -f /tmp/\$$
				echo \$PID >/var/run/optimmgmtserver.pid
			fi
			echo "."
		fi
	}

	_stop() {
		if [ -s /var/run/optimmgmtserver.pid ]
		then
			echo -n Stopping optim management service
			PID=\`cat /var/run/optimmgmtserver.pid\`
			# start-stop-deamon is not dependable on restart.  We use kill instead
			#start-stop-daemon -v --stop --chuid $USER --pidfile /var/run/optimmgmtserver.pid
			kill -9 \$PID
			RC=\$?
			if [ \$RC -eq 0 ] 
			then
				# If here, there was a process to kill.
				# Wait for the process to go away before deleting the pid file.
				ps -fu $USER -p $\PID >/dev/null 2>&1
				RC=\$?
				while [ \$RC -eq 0 ]
				do
					sleep 5
					ps -fu $USER -p $\PID >/dev/null 2>&1
					2:RC=\$?
					echo RC: \$RC
				done		
			fi
			# Always remove the pid file whether or not there was a server process to kill
			rm /var/run/optimmgmtserver.pid
			echo "."
		fi
	}

	case "\$1" in
		"start")
			_start
			;;
		"stop")
			_stop
			;;
		"restart")
			_stop
			_start
			;;
	esac
	EOF
	) > $OUTFILE
	chmod +x $OUTFILE
}

TYPE=`uname`

case "$TYPE" in
	"Linux")
		# Determine Linux flavor
		FLAVOR=`lsb_release -d | awk '{ print $2 }'`
		;;
	*)
		FLAVOR=$TYPE
		;;
esac

# Name of the init file to generate
OUTFILE=optimmgmtserver

# Ensure the script is executed from WAS-CE bin directory and
# set location for use in setting WAS-CE location in init script
HERE=`pwd`
cd ..
LOCATION=`pwd`
BASENAME=`basename $LOCATION`
if [ "$BASENAME" != "AppServerCommunityEdition" ]
then
	echo "ERROR: You must run this script from the WAS-CE bin directory" >&2
	exit 1
fi
# Determine the user account for the daemon to start service as
USER=`ls -ld | awk '{ print $3 }'`
cd $HERE

if [ "$FLAVOR" = "Red" ]
then
	createRedHatScript
elif [ "$FLAVOR" = "AIX" ]
then
	createAIXScript
elif [ "$FLAVOR" = "SunOS" ]
then
	createSunOSScript
elif [ "$FLAVOR" = "Ubuntu" ]
then
	createUbuntuScript
fi
